#include <genieArduino.h>

Genie genie;

// Displaying Temperature Readings from a Host
// 4D Systems
// This Demo communicates with a 4D Systems Display, configured with ViSi-Genie.
// The display has two LED digits objects for displaying temperature in degrees Celsius and Fahrenheit
// This sketch comes with a documentation (4D-AN-P4015 ViSi-Genie - Displaying Temperature Values from a Host)
// Download documentation here: http://www.4dsystems.com.au/appnotes/

  int tempC;           //holds temperature readings in degrees Celsius
  int tempF;           //holds temperature readings in degrees Fahrenheit
  int sensorPin = A0;  //Vout of LM35 is connected to A0 of Arduino host
  
void setup() 
{ 
  Serial.begin(9600);
  // a few options to talk to the Display, uncomment the preferred serial port and baud rate
  // make sure that the ViSi Genie program has the same baud rate
  genie.Begin(Serial);  //Serial0   
  //Reset the Display (change D4 to D2 if you have original 4D Arduino Adaptor)
  //See the app note 4D-AN-P4017-ViSi-Genie Connecting a 4D Display to an Arduino Host
  //for information if using jumper connecting wires
  pinMode(4, OUTPUT);   // Set D4 on Arduino to Output (4D Arduino Adaptor V2 - Display Reset)
  digitalWrite(4, 1);   // Reset the Display via D4
  delay(100);
  digitalWrite(4, 0);   // unReset the Display via D4
  
  delay (3500);         //let the display start up
}

void loop() 
{ 
  tempC = ((5.0 * analogRead(sensorPin) * 100.0) / 1024) + 2;  //signal level sampled from sensorPin is converted to a temperature value. Do calibration  if needed.
  genie.WriteObject(GENIE_OBJ_LED_DIGITS, 0x00, tempC);         //Write to Leddigits0 the value of tempC
  delay(50);
  tempF = tempC * 9 / 5 + 32;                                  //Convert temperature readings in degrees Celsius to degrees Fahrenheit
  genie.WriteObject(GENIE_OBJ_LED_DIGITS, 0x01, tempF);         //Write to Leddigits1 the value of tempF
  delay(50);
}



