#include <genieArduino.h>

// 4D Systems
// This Demo communicates with a 4D Systems Display, configured with ViSi-Genie.
// Demonstrates how to write to the different Genie objects
// This sketch comes with a Genie program and documentation


Genie genie;
#define RESETLINE 4  // Change this if you are not using an Arduino Adaptor Shield Version 2 (see code below)
void setup() 
{ 
  // NOTE, the genieBegin function (e.g. genieBegin(GENIE_SERIAL_0, 115200)) no longer exists.  Use a Serial Begin and serial port of your choise in
  // your code and use the genie.Begin function to send it to the Genie library (see this example below)

  Serial.begin(9600);  // Serial0 @ 200000 (200K) Baud
  genie.Begin(Serial);   // Use Serial0 for talking to the Genie Library, and to the 4D Systems display

  //genie.AttachEventHandler(myGenieEventHandler); // Attach the user function Event Handler for processing events 


  //Reset the Display (change D4 to D2 if you have original 4D Arduino Adaptor)
  pinMode(RESETLINE, OUTPUT);  // Set D4 on Arduino to Output (4D Arduino Adaptor V2 - Display Reset)
  digitalWrite(RESETLINE, 1);  // Reset the Display via D4
  delay(100);
  digitalWrite(RESETLINE, 0);  // unReset the Display via D4
  
  delay (10000); //let the display start up
  
  //Write a string to the Display
  genie.WriteStr(0, GENIE_VERSION);
  delay(2000);
}

void loop() 
{   
    int i, bar, value, combined, j, k;//used a counter
    
    //write to a dipswitch and a text string
    genie.WriteStr(0, "Dipswitch0 at 0");
    genie.WriteObject(GENIE_OBJ_DIPSW, 0x00, 0); 
    delay(3000);
    genie.WriteStr(0, "Dipswitch0 at 1");
    genie.WriteObject(GENIE_OBJ_DIPSW, 0x00, 1); 
    delay(3000);
    
    //write to a knob
    genie.WriteStr(0, "Knob0 at \nvarious states");
    for(i = 0; i<100; i++){
      genie.WriteObject(GENIE_OBJ_KNOB, 0x00, i); 
      delay(100);
    }
    delay(2000);
    
    //write to a rockerswitch
    genie.WriteStr(0, "Rockerswitch0 at 0");
    genie.WriteObject(GENIE_OBJ_ROCKERSW, 0x00, 0); 
    delay(3000);
    genie.WriteStr(0, "Rockerswitch0 at 1");
    genie.WriteObject(GENIE_OBJ_ROCKERSW, 0x00, 1); 
    delay(3000);
   
    //write to a rotary switch
    genie.WriteStr(0, "Rotaryswitch0 at\n various states");
    for(i = 0; i<9; i++){
      genie.WriteObject(GENIE_OBJ_ROTARYSW, 0x00, i); 
      delay(350);
    }
    delay(2000);
  
    
    //write to a slider
    genie.WriteStr(0, "Slider0 at \nvarious states");
    for(i = 0; i<100; i++){
      genie.WriteObject(GENIE_OBJ_SLIDER, 0x00, i); 
      delay(100);
    }  
    delay(2000);

    
    //write to a trackbar
    genie.WriteStr(0, "Trackbar0 at \nvarious states");
    for(i = 0; i<100; i++){
      genie.WriteObject(GENIE_OBJ_TRACKBAR, 0x00, i); 
      delay(100);
    }      
    delay(2000);
    
    
    //write to a winbutton
    genie.WriteStr(0, "Winbutton0 at 0");
    genie.WriteObject(GENIE_OBJ_WINBUTTON, 0x00, 0); 
    delay(3000);
    genie.WriteStr(0, "Winbutton0 at 1");
    genie.WriteObject(GENIE_OBJ_WINBUTTON, 0x00, 1); 
    delay(3000); 
    
    
    //navigate to Form1
    genie.WriteObject(GENIE_OBJ_FORM, 0x01,0);
    genie.WriteStr(1, "This is now \nForm1");
    delay(2000);    
    
    //write to an angular meter
    genie.WriteStr(1, "Angularmeter0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_ANGULAR_METER, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    //navigate to Form2
    genie.WriteObject(GENIE_OBJ_FORM, 0x02,0);
    genie.WriteStr(2, "This is now \nForm2");
    delay(2000);    
    
    //write to a cool gauge
    genie.WriteStr(2, "Coolgauge0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_COOL_GAUGE, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    
    //navigate to Form3
    genie.WriteObject(GENIE_OBJ_FORM, 0x03,0);
    genie.WriteStr(3, "This is now \nForm3");
    delay(2000);    
    
    
    //write to a custom digit
    genie.WriteStr(3, "Customdigits0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_CUSTOM_DIGITS, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    //write to a gauge
    genie.WriteStr(3, "Gauge0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_GAUGE, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    
    //write to an LED
    genie.WriteStr(3, "Led0 at 0");
    genie.WriteObject(GENIE_OBJ_LED, 0x00, 0); 
    delay(3000);
    genie.WriteStr(3, "Led0 at 1");
    genie.WriteObject(GENIE_OBJ_LED, 0x00, 1); 
    delay(3000);
    
    //write to a LED digits
    genie.WriteStr(3, "Leddigits0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_LED_DIGITS, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    
    //navigate to Form4
    genie.WriteObject(GENIE_OBJ_FORM, 0x04,0);
    genie.WriteStr(4, "This is now \nForm4");
    delay(2000);   
    
    //write to a thermometer
    genie.WriteStr(4, "Thermometer0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_THERMOMETER, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    //write to a meter
    genie.WriteStr(4, "Meter0 at \nvarious states");
    for(i = 0; i<100; i++){
    genie.WriteObject(GENIE_OBJ_METER, 0x00, i); 
    delay(100);}      
    delay(2000);
    
    
    //navigate to Form5
    genie.WriteObject(GENIE_OBJ_FORM, 0x05,0);
    genie.WriteStr(5, "This is now \nForm5");
    delay(2000);  
   
    
    //write to a user LED
    genie.WriteStr(5, "Userled0 at 0");
    genie.WriteObject(GENIE_OBJ_USER_LED, 0x00, 0); 
    delay(3000);
    genie.WriteStr(5, "Userled0 at 1");
    genie.WriteObject(GENIE_OBJ_USER_LED, 0x00, 1); 
    delay(3000);
    
    
    //write to a video
    genie.WriteStr(5, "display the different \nframes of Video0");
    for(i = 0; i<749; i++){
    genie.WriteObject(GENIE_OBJ_VIDEO, 0x00, i); 
    delay(40);}    
    
    //write to a predefined strings object
    genie.WriteStr(5, "Displaying a \npredefined\nstrings object");
    delay(5000);
    genie.WriteStr(5, "page 1 of Strings6\nis intentionally\nleft blank");
    genie.WriteObject(GENIE_OBJ_STRINGS, 0x06, 0);
    delay(3000);    
    genie.WriteStr(5, "page 2 of Strings6");
    genie.WriteObject(GENIE_OBJ_STRINGS, 0x06, 1);
    delay(7000);
    genie.WriteStr(5, "page 3 of Strings6");
    genie.WriteObject(GENIE_OBJ_STRINGS, 0x06, 2);
    delay(7000);
    genie.WriteStr(5, "page 4 of Strings6");
    genie.WriteObject(GENIE_OBJ_STRINGS, 0x06, 3);
    delay(7000);
    
    
    //navigate to Form6
    genie.WriteObject(GENIE_OBJ_FORM, 0x06,0);
    genie.WriteStr(7, "This is now\nForm6");
    delay(15000);  
    
    //write to a timer
    genie.WriteStr(7, "Start Timer0");
    genie.WriteObject(GENIE_OBJ_TIMER, 0x00,1);
    delay(5000);  
    genie.WriteStr(7, "Stop Timer0");
    genie.WriteObject(GENIE_OBJ_TIMER, 0x00,0);
    delay(5000);  
    genie.WriteStr(7, "Timer0 resumes");
    genie.WriteObject(GENIE_OBJ_TIMER, 0x00,1);
    delay(5000);  
    genie.WriteStr(7, "Timer0 stops");
    genie.WriteObject(GENIE_OBJ_TIMER, 0x00,0);    
    genie.WriteObject(GENIE_OBJ_VIDEO, 0x01,0); //reset Video1 to frame 0    
    delay(5000);  
    

     //navigate to Form7
    genie.WriteObject(GENIE_OBJ_FORM, 0x07,0);
    genie.WriteStr(8, "This is now \nForm7");
    delay(15000);
    
    //write to Sounds0. There can only be one sounds object.
    //Object index is used to determine the command
    //Object index      meaning (Value field)
    //    0             Play wav file n
    //    1             Set Volume n
    //    2             Pause
    //    3             Continue
    //    4             Stop
    
    //start playing track 1   
    genie.WriteStr(8, "Play track 1");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x00,0);
    //set volume
    genie.WriteStr(9, "volume = 100");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x01,100);
    delay(7000); 
    
    //start playing track 2
    genie.WriteStr(8, "Play track 2");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x00,1);
    //control volume
    genie.WriteStr(9, "volume = 75");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x01,75);
    delay(7000); 
    //pause current track (track 2)
    genie.WriteStr(8, "Pause track 2");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x02,0);//third argument can be of any value
    delay(3000); 
    //resume current track (track 2)
    genie.WriteStr(8, "Continue \ntrack 2");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x03,0);//third argument can be of any value
    delay(5000); 
    //stop current track (track 2). Track goes back to the start
    genie.WriteStr(8, "Stop track 2");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x04,0);//third argument can be of any value
    delay(3000); 
    
    //start playing track 3   
    genie.WriteStr(8, "Play track 3");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x00,2);
    genie.WriteStr(9, "volume = 100");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x01,100);
    delay(7000); 
    //stop current track (track 3). Track goes back to the start
    genie.WriteStr(8, "Stop track 3");
    genie.WriteObject(GENIE_OBJ_SOUND, 0x04,0);//third argument can be of any value
    delay(3000); 
    
    
    //navigate to Form8
    genie.WriteObject(GENIE_OBJ_FORM, 0x08,0);    
    genie.WriteStr(10, "This is \nnow Form8.");
    
    for(i = 0; i < 250; i++){
      bar = random(0, 23);
      value = random(0,99);
      combined = (bar << 8) | value;
      genie.WriteObject(GENIE_OBJ_SPECTRUM, 0x00, combined); 
      delay(20);     
    }
    
    //navigate to Form9
    genie.WriteObject(GENIE_OBJ_FORM, 0x09,0);
    genie.WriteStr(11, "This is \nnow Form9.");
    
    for(i = 0; i < 263; i++){
      genie.WriteObject(GENIE_OBJ_SCOPE, 0x00, random(0, 160)); 
      delay(50);     
    }
    
    //navigate to Form10
    genie.WriteObject(GENIE_OBJ_FORM, 0x0A,0);
    genie.WriteStr(12, "This is \nnow Form10.");    
    for(i = 0; i < 100; i++){
      genie.WriteObject(GENIE_OBJ_TANK, 0x00, i); 
      genie.WriteObject(GENIE_OBJ_LED_DIGITS, 0x01, i);
      delay(50);     
    }   
    
    //navigate to Form11
    genie.WriteObject(GENIE_OBJ_FORM, 0x0B,0);
    genie.WriteStr(13, "This is \nnow Form11.");    
    for(i = 0; i < 10; i++){
      j = random(0, 3);
      genie.WriteObject(GENIE_OBJ_USERIMAGES, 0x00, j); 
      genie.WriteObject(GENIE_OBJ_USERIMAGES, 0x01, i); 
      delay(1000);     
    }   
    
    
    //navigate to Form12
    genie.WriteObject(GENIE_OBJ_FORM, 0x0C,0);
    genie.WriteStr(14, "This is \nnow Form12.");
    delay(1000);   
    j = 0;  
    for(i = 0; i < 10; i++){
      genie.WriteObject(GENIE_OBJ_PINOUTPUT, 0x00, random(0,1)); //PinOutput0 has a defined pulse duration. Writing any value to it will activate the pulse.
      genie.WriteObject(GENIE_OBJ_USER_LED, 0x01, 1);            //Userled1 indicates state of PinOutput0
      delay(1000);
      genie.WriteObject(GENIE_OBJ_USER_LED, 0x01, 0); 
      delay(1000);                                               //wait for the pulse to complete     
      
      genie.WriteObject(GENIE_OBJ_PINOUTPUT, 0x01, j);           
      genie.WriteObject(GENIE_OBJ_USER_LED, 0x02, j);            //Userled2 indicates state of PinOutput1
      delay(50);     
      j = !j;
    } 
    
    //navigate to Form13
    genie.WriteObject(GENIE_OBJ_FORM, 0x0D,0);
    genie.WriteStr(15, "This is now Form13.");
    delay(2000);    
    
    for(i = 0; i < 8; i++){
      for(j = 0; j < 4; j++){
        genie.WriteObject(GENIE_OBJ_4DBUTTON, i, 1);
        delay(100); 
        genie.WriteObject(GENIE_OBJ_4DBUTTON, i, 0); 
        delay(100);   
      }  
    } 
    
    //navigate to Form14
    genie.WriteObject(GENIE_OBJ_FORM, 0x0E,0);
    genie.WriteStr(16, "This is now Form14.");
    delay(2000);    
    
    for(i = 0; i < 5; i++){      
      for(j = 0; j < 5; j++){
        genie.WriteObject(GENIE_OBJ_ANIBUTTON, 0x00, j);
        delay(100); 
      } 
      
      for(j = 5; j > 0; j--){
        genie.WriteObject(GENIE_OBJ_ANIBUTTON, 0x00, j);
        delay(100); 
      } 
    }

    //navigate to Form15
    genie.WriteObject(GENIE_OBJ_FORM, 0x0F,0);
    genie.WriteStr(17, "This is now Form15.");
    delay(2000);    
    
    for(j = 0; j < 10; j++){
      i = random(0, 0xFFFF);
      genie.WriteObject(GENIE_OBJ_COLORPICKER, 0x00, i);
      delay(500); 
    } 
      
    //navigate to Form16
    genie.WriteObject(GENIE_OBJ_FORM, 0x10,0);
    genie.WriteStr(18, "This is now Form16.");
    delay(2000);    
    
    for(j = 0; j < 10; j++){
      genie.WriteObject(GENIE_OBJ_USERBUTTON, 0x00, j & 0x01);
      genie.WriteObject(GENIE_OBJ_USERBUTTON, 0x01, j & 0x01);
      delay(500); 
    } 
    
    //navigate back to Form1
    genie.WriteObject(GENIE_OBJ_FORM, 0x00,0);    
}
